<template>
  <div>
    <canvas ref="myCanvas" width="250" height="250" class="border"></canvas>
    <div class="mt-4">
      <div class="slider-demo-block">
        <span class="demonstration">Kích cỡ</span>
        <el-slider v-model="size" :min="-5" :max="20" :show-tooltip="false" />
      </div>
      <div class="slider-demo-block">
        <span class="demonstration">Xoay</span>
        <el-slider v-model="rotate" :min="-180" :max="180" />
      </div>
      <div>
        <el-text tag="b">Nội dung</el-text>
        <el-input
          v-model="text"
          :rows="2"
          type="textarea"
          placeholder="Please input"
        />
      </div>
    </div>
  </div>
</template>

<script setup>
import { onMounted, ref, watch } from "vue";
const props = defineProps(["image"]);
const emit = defineEmits(["update:image"]);

const text = ref(props.image.text);
const size = ref(props.image.size);
const rotate = ref(props.image.rotate);

const defaultSize = 20;

const myCanvas = ref(null);

let ctx;

const draw = () => {
  ctx.fillStyle = "#fff";
  ctx.fillRect(0, 0, myCanvas.value.width, myCanvas.value.height);
};

onMounted(() => {
  if (myCanvas.value) {
    ctx = myCanvas.value.getContext("2d");
    updateText();
  }
});


const updateText = () => {
  if (text.value) {
    fillText(text.value, size.value, rotate.value);
  }
};

watch(text, updateText);
watch(size, updateText);
watch(rotate, updateText);

const fillText = (text, size, rotate) => {
  const x = myCanvas.value.width / 2;
  const y = myCanvas.value.height / 2;
  ctx.clearRect(0, 0, myCanvas.value.width, myCanvas.value.height);

  draw();

  const fontSize = defaultSize + size;

  ctx.font = `${fontSize}px Arial`;

  const angleInRadians = (rotate * Math.PI) / 180;

  ctx.save();

  ctx.fillStyle = "#000";
  ctx.textAlign = "center";
  ctx.textBaseline = "middle";

  ctx.translate(x, y);
  ctx.rotate(angleInRadians);
  ctx.fillText(text, 0, 0);
  ctx.restore();

  const base64Url = myCanvas.value.toDataURL("image/jpeg", 1);

  emit("update:image", {
    type: "base64",
    src: base64Url,
    size: fontSize,
    text,
    rotate,
  });
};
</script>
